# PART 2, different local minima
from casadi import *
import numpy
from matplotlib import pylab as plt
# Domain
x = numpy.linspace(-2.5, 1.5, 1000)
y = numpy.linspace(-3.5, 1.5, 1000)
[X,Y] = plt.meshgrid(x, y)
# Function

F = numpy.exp(-X**2 - Y**2)*numpy.sin(4*(X + Y + X * Y**2))

# Plot the function
plt.clf()
plt.contour(X,Y,F,50)
plt.colorbar()
plt.jet()
plt.xlabel('x')
plt.ylabel('y')


# solve with different starting points
xy = SX.sym('xy',2)
x = xy[0]
y = xy[1]
f = exp(-x**2 - y**2)*sin(4*(x + y + x * y**2))
nlp = SXFunction( nlpIn(x=xy), nlpOut(f=f) )
solver = NlpSolver('ipopt',nlp)
solver.setOption('tol',1e-12)
solver.init()
#solver.setInput([-inf,-inf],'lbx')
#solver.setInput([inf,inf],'ubx')

blah = []
for starting_point in [[0,0], [0.9,0.9], [-0.9,-0.9]]:
    solver.setInput(starting_point, 'x0')
    solver.evaluate()
    xyOpt = solver.getOutput('x')
    blah.append((starting_point, xyOpt, solver.getStats()['return_status']))
    plt.plot([starting_point[0],xyOpt[0]], [starting_point[1],xyOpt[1]],'ro-')

for b in blah: print b
plt.show()
